"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;
var _fs = _interopRequireDefault(require("fs"));
var _sharp = _interopRequireDefault(require("sharp"));
var _error = require("@azteam/error");
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _typeof(obj) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (obj) { return typeof obj; } : function (obj) { return obj && "function" == typeof Symbol && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }, _typeof(obj); }
function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }
function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, _toPropertyKey(descriptor.key), descriptor); } }
function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
var SharpImage = /*#__PURE__*/function () {
  function SharpImage() {
    _classCallCheck(this, SharpImage);
  }
  _createClass(SharpImage, null, [{
    key: "getImageInfo",
    value: function getImageInfo(imgPath) {
      return (0, _sharp["default"])(imgPath).metadata().then(function (metadata) {
        return metadata;
      })["catch"](function (err) {
        throw new _error.ErrorException(_error.FILE_TYPE, {
          mime: 'undefined',
          message: err.toString()
        });
      });
    }
  }, {
    key: "resizeToPipe",
    value: function resizeToPipe(imgPath) {
      var format = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;
      var width = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;
      var height = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : null;
      var readStream = _fs["default"].createReadStream(imgPath);
      var pipeline = (0, _sharp["default"])();
      if (format) {
        pipeline = pipeline.toFormat(format);
      }
      if (width || height) {
        if (width && height) {
          pipeline = pipeline.resize(parseInt(width, 10), parseInt(height, 10), {
            // kernel: sharp.kernel.nearest,
            fit: 'contain',
            background: {
              r: 255,
              g: 255,
              b: 255
            }
          });
        } else {
          pipeline = pipeline.resize(parseInt(width, 10));
        }
      }
      try {
        pipeline = pipeline.sharpen();
        return readStream.pipe(pipeline);
      } catch (e) {
        console.error(err);
        throw new Error("resizeToPipe ".concat(imgPath, " failed"));
      }
    }
  }, {
    key: "resizeToFile",
    value: function resizeToFile(imgPath, newImgPath) {
      var format = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : null;
      var width = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : null;
      var height = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : null;
      try {
        var pipeline = (0, _sharp["default"])(imgPath);
        if (format) {
          pipeline = pipeline.toFormat(format);
        }
        if (width || height) {
          if (width && height) {
            pipeline = pipeline.resize(parseInt(width, 10), parseInt(height, 10), {
              // kernel: sharp.kernel.nearest,
              fit: 'contain',
              background: {
                r: 255,
                g: 255,
                b: 255
              }
            });
          } else {
            pipeline = pipeline.resize(parseInt(width, 10));
          }
        }
        return pipeline.toFile(newImgPath);
      } catch (err) {
        console.error(err);
        throw new Error("resizeToFile ".concat(imgPath, " failed"));
      }
    }

    // async addWatermark(imgPath, watermarkPath) {
    //     const imgInfo = await SharpImage.getImageInfo(imgPath),
    //         watermarks = fs.readdirSync(watermarkPath),
    //         watermark_size = Math.floor(imgInfo.width / 5),
    //         top = Math.floor(imgInfo.height - watermark_size - watermark_size / 6),
    //         left = Math.floor(imgInfo.width - watermark_size - watermark_size / 6),
    //         input = await sharp(watermarkPath, {failOnError: false}).resize(watermark_size, watermark_size).toBuffer();
    //
    //     return sharp(imgPath)
    //         .composite([
    //             {
    //                 input,
    //                 top,
    //                 left,
    //                 blend: 'overlay',
    //             },
    //         ])
    //         .toBuffer();
    // }
  }]);
  return SharpImage;
}();
var _default = SharpImage;
exports["default"] = _default;